'BAT-MOD2.BAS
'support module for BATTLE.BAS

DEFINT A-Z
'$INCLUDE: 'dash.bi'
'$INCLUDE: 'bwsb.bi'
'$INCLUDE: 'gdmtype.bi'
'$INCLUDE: 'gslib.bi'
'$DYNAMIC

DECLARE SUB waitforit ()
DECLARE SUB setvm (answer%)

REM $STATIC
SUB buggeredout (errornumber)
CLS
PALETTE
SCREEN 0
WIDTH 80
COLOR 15
PRINT "THE WRATH OF SONA IDAL SYSTEM build 0.47"
PRINT "ERROR DETECTION returned the following error:"
SELECT CASE errornumber
        CASE 1: PRINT "Base I/O address autodetection failure": END
        CASE 2: PRINT "IRQ level autodetection failure": END
        CASE 3: PRINT "DMA channel autodetection failure": END
        CASE 4: PRINT "DMA channel not supported": END
        CASE 6: PRINT "Sound device does not respond": END
        CASE 7: PRINT "Memory control blocks destroyed": END
        CASE 8: PRINT "Insufficient memory for mixing buffers": END
        CASE 9: PRINT "Insufficient memory for MSE file": END
        CASE 10: PRINT "MSE has invalid identification string (corrupt/non-existant)": END
        CASE 11: PRINT "MSE disk read failure": END
        CASE 12: PRINT "MVSOUND.SYS not loaded (required for PAS use)": END
        CASE 13: PRINT "Module is corrupt": END
        CASE 14: PRINT "Could not autodetect module type": END
        CASE 15: PRINT "Bad format ID or module not found": END
        CASE 16: PRINT "Out of memory for GDM file": END
        CASE 17: PRINT "Cannot unpack samples in GDM file": END
        CASE 18: PRINT "AdLib samples not supported-GDM sample error": END
        CASE 19: PRINT "GIF error-Not a GIF file.": END
        CASE 20: PRINT "GIF error-Unknown GIF extension type.": END
        CASE 21: PRINT "GIF error-File not found.": END
        CASE 24: PRINT "Missing STATS.DAT file in DATA subdirectory.": END
        CASE 25: PRINT "Missing VIRTUAL.MEM file in DATA subdirectory.": END
        CASE 27: PRINT "Missing WOS-BOX?.PUT file in the TILES subdirectory.": END
        CASE 32: PRINT "K6A error.": END
        CASE ELSE: PRINT "Undefined program error-like a GP Fault in WindBlow$!": END
END SELECT
END
END SUB

SUB DelayFrame (thetime)
   seconds! = thetime / 100
   DEF SEG = 0
   d& = FIX(seconds! * 18.20444444#)
   FOR T& = 0 TO d&
     d% = PEEK(&H46C) AND 255
     DO WHILE d% = (PEEK(&H46C) AND 255)
     LOOP
   NEXT T&
END SUB

SUB ripple
DIM wavesl(318) AS LONG, wavesr(2) AS LONG
DIM a AS INTEGER, B AS INTEGER, c AS INTEGER
   FOR a = 1 TO 200 STEP 2
      FOR B = 1 TO 200 STEP 20
         c = (a + B) MOD 197
         GET (0, c)-(317, c + 3), wavesl
         GET (318, c)-(319, c + 3), wavesr
         PUT (0, c), wavesr, PSET
         PUT (2, c), wavesl, PSET
      
         c = (a + B + 10) MOD 197
         GET (2, c)-(319, c + 3), wavesl
         GET (0, c)-(1, c + 3), wavesr
         PUT (318, c), wavesr, PSET
         PUT (0, c), wavesl, PSET
         'WAIT &H3DA, 8
      NEXT B
   NEXT a
END SUB

SUB ripple2
DIM wavesl(318) AS LONG, wavesr(2) AS LONG
   FOR a = 0 TO 96 STEP 2
      FOR B = 1 TO 200 STEP 15
         c = (a + B) MOD 197
         GET (0, c)-(317, c + 3), wavesl
         GET (318, c)-(319, c + 3), wavesr
         PUT (0, c), wavesr, PSET
         PUT (2, c), wavesl, PSET
   
         c = (a + B + 10) MOD 197
         GET (2, c)-(319, c + 3), wavesl
         GET (0, c)-(1, c + 3), wavesr
         PUT (318, c), wavesr, PSET
         PUT (0, c), wavesl, PSET
         
         WAIT &H3DA, 8
      NEXT B
   NEXT a
END SUB

SUB SaveScreen
biteityouscum = FREEFILE
OPEN "SAMPLER.IDX" FOR BINARY AS #biteityouscum
IF LOF(biteityouscum) = 0 THEN
        CLOSE biteityouscum
        KILL "SAMPLER.IDX"
        OPEN "O", #biteityouscum, "SAMPLER.IDX"
        WRITE #biteityouscum, 0
        CLOSE biteityouscum
END IF
CLOSE biteityouscum
OPEN "I", #biteityouscum, "SAMPLER.IDX"
INPUT #biteityouscum, samplenumber
CLOSE biteityouscum
samplenumber = samplenumber + 1
OPEN "O", #biteityouscum, "SAMPLER.IDX"
WRITE #biteityouscum, samplenumber
CLOSE biteityouscum
saveit$ = STR$(samplenumber)
saveit$ = LTRIM$(RTRIM$(saveit$))
FileNamerS$ = "SMPL" + saveit$ + ".SBS"

DEF SEG = &HA000
OUT &H3C7, 0
FOR a = 0 TO 767
    POKE a + 64000, INP(&H3C9)
NEXT
BSAVE FileNamerS$, 0, 64768
END SUB

SUB shake
DIM wavesl(16000) AS LONG, wavesr(400) AS LONG
   GET (0, 0)-(317, 199), wavesl
   GET (318, 0)-(319, 199), wavesr
   PUT (0, 0), wavesr, PSET
   PUT (2, 0), wavesl, PSET
  
   FOR a% = 0 TO 50
         GET (4, 0)-(319, 199), wavesl
         GET (0, 0)-(3, 199), wavesr
         PUT (0, 0), wavesl, PSET
         PUT (316, 0), wavesr, PSET
         WAIT &H3DA, 8
         GET (0, 0)-(315, 199), wavesl
         GET (316, 0)-(319, 199), wavesr
         PUT (0, 0), wavesr, PSET
         PUT (4, 0), wavesl, PSET
   NEXT
   GET (2, 0)-(319, 199), wavesl
   GET (0, 0)-(1, 199), wavesr
   PUT (318, 0), wavesr, PSET
   PUT (0, 0), wavesl, PSET
END SUB

